---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:10
---


local AddonName, BohemkaDKP = ...

BohemkaDKP.frames = {}
BohemkaDKP.roster = {}
BohemkaDKP.rosterIndex = {}
BohemkaDKP.sortedRoster = {}
BohemkaDKP.guildRoster = {}
BohemkaDKP.bidInfo = {}
BohemkaDKP.bidHistory = {}
BohemkaDKP.editModeSelected = {}
BohemkaDKP.passedHistory = {}
BohemkaDKP.suspects = {}
BohemkaDKP.conflicts = {}
BohemkaDKP.onlineChecks = {}
BohemkaDKP.currentItem = nil
BohemkaDKP.sharedCrafts = {}


function BohemkaDKP:OnLoad()
    self.onlineSince = GetServerTime()
    self:HookScripts()
    self:HookLootFrame()
    C_GuildInfo.GuildRoster();
    self:UpdateCompatibility()
    self:LoadUI()
    if not Crafts then
        Crafts = {}
    end
end
function BohemkaDKP:LoadDataWhenReady()
    if GetNumGuildMembers() == 0 then
        C_Timer.After(1, function ()
            BohemkaDKP:LoadDataWhenReady()
        end)
    else
        self.firstLoad = false
        if DKPLog.current then
            local guildName = GetGuildInfo("player")
            DKPLog[guildName] = BohemkaDKP:deepCopy(DKPLog)
            DKPLog.backup = nil
            DKPLog.current = nil
            DKPLog.lastBackup = nil
        end
        self:InitDKPLog()
        self:CleanUpLogs()

        self:CacheGuildRoster()
        self:CleanUpOldMembers()
        self:RequestPlayerInfo()
        C_Timer.After(300, function ()
            self:CheckAutoBackup()
        end)

        self:InitialSync()
        self:SaveCharacterInfo()
    end
end
function BohemkaDKP:LoadUI()
    self:AddStaticPopups()
    self:CreateInterfaceConfig()
    self:CreateAuctionFrame()
    self:AdjustUI()
end
function BohemkaDKP:OnUpdateCompatibilityCallback() end
function BohemkaDKP:OnUiAdjustedCompatibilityCallback()
end
function BohemkaDKP:CheckCompatibility()
    name, title, notes, loadable, reason, security, newVersion = GetAddOnInfo("ElvUI")
    self.isElvUI = loadable
end
function BohemkaDKP:GetCurrentGuildButtonFrameNamePrefix()
    if FriendsFrame.playerStatusFrame then
        return "GuildFrameButton"
    else
        return "GuildFrameGuildStatusButton"
    end
end

function BohemkaDKP:CacheGuildRoster()
    local newRoster = {}
    local newRosterIndex = {}
    local newRosterDKP= {}
    local n = 0
    local totalMembers, _, _ = GetNumGuildMembers();
    local canEdit = CanEditPublicNote()
    local canEditOfficer = CanEditOfficerNote()
    for i = 0, totalMembers do
        fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway, classFileName = GetGuildRosterInfo(i);
        if fullName then
            newRoster[fullName] = { fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway, classFileName }
            newRosterIndex[fullName] = i
            local currentDKP = self:NoteDKPToNumber(note)
            if self.roster[fullName] ~= currentDKP then
                self.suspects[fullName] = currentDKP
            end
            if currentDKP == nil and canEdit then
                currentDKP = BohemkaDKPConfig.startingDKP
                if canEditOfficer and note ~= nil and note ~= "" then
                    GuildRosterSetOfficerNote(i, note)
                end
                self:SaveDKP(i, currentDKP, nil, "Initial DKP")
            end
            newRosterDKP[fullName] = currentDKP
            n = n + 1
        end
    end
    self.guildRoster = newRoster
    self.rosterIndex = newRosterIndex
    self.roster = newRosterDKP

    self.checkedCheaters = false
    self.checkCheatersIn = 5
end


function BohemkaDKP:SendEvent(channel, event, ...)
    BohemkaDKP:Debug(event, "Processing payload for event", ...)
    local payload = self:PreparePayload(event, ...)
    if not payload then
        return
    end
    BohemkaDKP:Debug(event, "Sending event", channel, payload)
    self:SendAddonMessage(payload, channel)
end

function BohemkaDKP:SendEventTo(target, event, ...)
    BohemkaDKP:Debug(event, "Processing payload for event", ...)
    local payload = self:PreparePayload(self.EVENT.WHISPER, event, target, ...)
    if not payload or (self.guildRoster[target] and not self.guildRoster[target][9]) then
        return
    end
    BohemkaDKP:Debug(event, "Sending event to", target, payload)
    self:SendAddonMessage(payload, "GUILD")

end
function BohemkaDKP:SendAddonMessage(payload, ...)
    local cps = #payload + self.cpsOverhead
    if cps > BohemkaDKP:GetCPSLimit() then
        table.insert(self.cpsQueue, {payload, ...})
        return
    end
    self.cps = self.cps + cps
    C_ChatInfo.SendAddonMessage(AddonName, payload, ...)
end
function BohemkaDKP:PreparePayload(event, ...)
    local data = {...}
    if BohemkaDKPConfig.debug then
        for _, v in ipairs(data) do
            if v == nil or type(v) == "boolean" then
                self:Print("Wrong data to send", event, v)
                return
            end
        end
    end
    local payload = table.concat(table.removeNil(data), self.EVENT_SEPARATOR)
    if #payload > 0 then
        payload = event..self.EVENT_SEPARATOR..payload
    else
        payload = event
    end
    return payload
end

function BohemkaDKP:GetClassFileName(name)
    local classFileName
    if self.guildRoster[name] then
        local _, _, _, _, _, _, _, _, _, _, classFileName2  = unpack(self.guildRoster[name])
        classFileName = classFileName2
    else
        local shortName = strsplit("-", name)
        local _, classFileName2, _ = UnitClass(shortName)
        classFileName = classFileName2
    end
    return classFileName
end

function BohemkaDKP:GetClassColor(name)
    local classFileName = self:GetClassFileName(name)
    return RAID_CLASS_COLORS[classFileName]
end

function BohemkaDKP:AddClassColorToName(name)
    local shortName = strsplit("-", name)
    local color = self:GetClassColor(name)
    if color then
        local escapeColor = format("|cff%02x%02x%02x", color.r*255, color.g*255, color.b*255)
        shortName = escapeColor..shortName.."|r"
    end
    return shortName
end

function BohemkaDKP:GetBroadcastChannel()
    if IsInRaid() then
        return "RAID"
    end
    if IsInGroup() then
        return "PARTY"
    end
    return "GUILD"
end
function BohemkaDKP:ChatBid(msg, sender)
    local number = tonumber(msg)
    if BohemkaDKP.currentItem and number then
        number = number - BohemkaDKP.currentItem.price
        BohemkaDKP:OnBidRequest(number, BohemkaDKP.currentItem.auctionId, sender)
    elseif msg == "pass" then
        BohemkaDKP:Pass()
    end
end
function BohemkaDKP:OnOnlineCheck(sender)
    self:SendEventTo(sender, self.EVENT.ONLINE_CHECK_RESPONSE, self.onlineSince, BohemkaDKPConfig.lastTimeOnline or 0)
end

function BohemkaDKP:OnOnlineCheckResponse(time, lastTimeOnline, sender)
    if sender == self:GetPlayerName(true) then
        return
    end
    table.insert(self.onlineChecks, { onlineSince = tonumber(time), lastTimeOnline = tonumber(lastTimeOnline) or 0, name = sender})
end

function BohemkaDKP:SharePlayerData()
    self:ShareTalents()
    self:ShareCharactersInfo()
    self:ShareProfessions()
    self:ShareCraftHistory()
end
function BohemkaDKP:RequestPlayerInfo()
    self:RequestProfessionInfo()
    self:RequestTalentsInfo()
    self:RequestCharactersInfo()
end
function BohemkaDKP:CanStartAuctionWithClick()
    return self.MODIFIERS[BohemkaDKPConfig.startAuctionModifier]()
end
function BohemkaDKP:OnWhisper(event, target, ...)
    if target ~= self:GetPlayerName(true) then
        return
    end
    if self.events[event] then
        self.events[event](self, ...)
    end
end
function BohemkaDKP:GetGuildName(unit)
    local guildName = GetGuildInfo(unit or "player")
    return guildName
end
function BohemkaDKP:IsPlayerOnline(name)
    local data = self.guildRoster[name or self:GetPlayerName(true)]
    if data then
        return select(9, unpack(data))
    end

end
function BohemkaDKP:CleanUpOldMembers()
    for playerName, _ in pairs(Crafts) do
        local inGuild = false
        for name, _ in pairs(self.guildRoster) do
            if playerName == name then
                inGuild = true
                break
            end
        end
        if not inGuild then
            Crafts[playerName] = nil
        end
    end

end
