---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:14
---

local _, BohemkaDKP = ...

function GuildStatus_UpdateHook()
    local members = GetNumGuildMembers()
    if members > 0 and not BohemkaDKP.firstLoad then
        BohemkaDKP:CacheGuildRoster()
        BohemkaDKP:RefreshTotalDKP()
        BohemkaDKP:UpdateBidButtonState()
        BohemkaDKP:GuildStatusUpdateUI()
    end
end

function BohemkaDKP:GuildStatusUpdateUI()
    self:AdjustGuildFramesAfterUpdate()
    self:UpdateDetailFrame()
    self:UpdateUIGuildPermissions()
    self:UpdateAuctionUIState()
    self:RenderBench()
end

hooksecurefunc("GuildStatus_Update", GuildStatus_UpdateHook)
--for i = 1, NUM_CHAT_WINDOWS do
--    local tmp = _G["ChatFrame"..i].AddMessage
--    _G["ChatFrame"..i].AddMessage = function(self, text, r, g, b, messageId, holdTime)
--        if BohemkaDKPConfig.showCharNameInChat then
--            local regex = '|Hplayer:(%u+.+-%a+):'
--            local name = text:match(regex)
--            if name then
--                local charData = BohemkaDKP:GetGuildMemberCharactersData(name)
--                if charData then
--                    local mainName = BohemkaDKP:GetMainCharacter(charData)
--                    mainName = BohemkaDKP:AddRealmName(mainName)
--                    if mainName ~= name then
--                    -- if mainName ~= name and name ~= BohemkaDKP:GetPlayerName(true) then
--                        local nameLink = GetPlayerLink(name, BohemkaDKP:AddClassColorToName(name))
--                        local mainNameLink = GetPlayerLink(mainName, BohemkaDKP:AddClassColorToName(mainName))
--                        name = format("|r (%s): ", mainNameLink)
--
--                        local t = ""
--                        for j=1, #text do
--                            t = t.." "..text:sub(j, j)
--                        end
--                        local index = self.historyBuffer:CalculateElementIndex(1)
--                        self.historyBuffer.elements[index].message = text
--                    end
--                end
--            end
--        end
--        tmp(self, text, r, g, b, messageId, holdTime)
--    end
--end

hooksecurefunc("RaidFrame_LoadUI", function()
    BohemkaDKP:CreateBenchFrame()
end)
--hooksecurefunc("FriendsFrameDropDown_Initialize", function(self, level)
--    if level == 1 then
--        UIDropDownMenu_AddSeparator()
--        local info = UIDropDownMenu_CreateInfo();
--        info.text = "DKP";
--        info.isTitle = true
--        info.notCheckable = true;
--        info.fontObject = GameFontNormalLeft
--        info.value = "DKP"
--        UIDropDownMenu_AddButton(info);
--
--        local name = self.name.."-"..GetRealmName()
--
--        info = UIDropDownMenu_CreateInfo();
--        info.text = "Bench"
--        info.icon = 135942
--        if BohemkaDKPConfig.bench[name] then
--            info.checked = 1;
--        else
--            info.checked = nil;
--        end
--        info.func = function()
--            local bench = BohemkaDKPConfig.bench
--            bench[name] = not bench[name]
--            BohemkaDKP:RenderBench()
--        end;
--        UIDropDownMenu_AddButton(info);
--    end
--end)

function BohemkaDKP:HookScripts()
    local defaultWidth = FriendsFrame:GetWidth()
    GuildFrame:HookScript("OnShow", function()
        if not InCombatLockdown() then
            FriendsFrame:SetWidth(BohemkaDKP:GetFriendsFrameWidth())
            BohemkaDKP:PositionGuildCraftFrame()
        end
    end)
    FriendsFrame:HookScript("OnHide", function()
        if not InCombatLockdown() then
            BohemkaDKP:PositionGuildCraftFrame()
        end
    end)

    for i = 1, FRIENDS_FRAME_TAB_COUNT do
        button = getglobal("FriendsFrameTab"..i);
        button:HookScript("OnClick", function(...)
            local tabIndex = PanelTemplates_GetSelectedTab(FriendsFrame)
            if tabIndex ~= 3 then
                if not InCombatLockdown() then
                    FriendsFrame:SetWidth(defaultWidth)
                    BohemkaDKP:PositionGuildCraftFrame()
                end
            end
        end)
    end
end


function BohemkaDKP:HookLootFrame()
    if self.isElvUI then
        local fn = ElvUI[1].Bags.ConstructContainerButton
        ElvUI[1].Bags.ConstructContainerButton = function(...)
            local frame = fn(...)
            BohemkaDKP:HookContainerItemFrame(frame)
            return frame
        end

    end

    for i = 1, 4 do
        BohemkaDKP:HookLootItemFrame(_G["LootButton"..i], i)
    end
    for i = 1, 11 do
        local n = 1
        while true do
            local itemFrame = getglobal("ContainerFrame"..i.."Item"..n)
            if not itemFrame then
                break
            end
            BohemkaDKP:HookContainerItemFrame(itemFrame)
            n = n + 1
        end

    end
end

function BohemkaDKP:HookLootItemFrame(frame, index)
    frame:HookScript("OnClick", function()

        if (BohemkaDKP:CanStartAuctionWithClick()) then
            local numLootItems = GetNumLootItems()
            local numLootToShow = LOOTFRAME_NUMBUTTONS;
            if ( numLootItems > LOOTFRAME_NUMBUTTONS ) then
                numLootToShow = numLootToShow - 1; -- make space for the page buttons
            end
            local slot = (numLootToShow * (LootFrame.page - 1)) + index;
            local texture, item, quantity, currencyID, quality, _, _, _, _ = GetLootSlotInfo(slot);
            if ( currencyID ) then
                item, texture, quantity, quality = CurrencyContainerUtil.GetCurrencyContainerInfo(currencyID, quantity, item, texture, quality);
            end

            local itemLink = GetLootSlotLink(slot)
            BohemkaDKP:StartAuction(itemLink, quantity, frame)

        end
    end)
end

function BohemkaDKP:HookLootItemFrameElvUI(frame, index)
    frame:HookScript("OnClick", function()
        if (BohemkaDKP:CanStartAuctionWithClick()) then
            local texture, item, quantity, currencyID, quality, _, _, _, _ = GetLootSlotInfo(index);
            if ( currencyID ) then
                item, texture, quantity, quality = CurrencyContainerUtil.GetCurrencyContainerInfo(currencyID, quantity, item, texture, quality);
            end

            local itemLink = GetLootSlotLink(index)
            BohemkaDKP:StartAuction(itemLink, quantity, frame.iconFrame)
        end
    end)
end


function BohemkaDKP:HookContainerItemFrame(frame)
    frame:HookScript("OnClick", function(self)
        if (BohemkaDKP:CanStartAuctionWithClick()) then
            texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(self:GetParent():GetID(), self:GetID());
            BohemkaDKP:StartAuction(itemLink, itemCount, frame)
        end
    end)
end
