---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 15.07.2021 17:53
---
local _, BohemkaDKP = ...

function BohemkaDKP:SaveCharacterInfo()
    local realm = GetRealmName()
    if not AccountData.characters[realm] then
        AccountData.characters[realm] = {}
    end

    local guildName, guildRankName, guildRankIndex  = GetGuildInfo("player")
    if not guildName then
        return
    end
    if not AccountData.characters[realm][guildName] then
        AccountData.characters[realm][guildName] = {}
    end
    AccountData.characters[realm][guildName][self:GetPlayerName(true)] = {rank = guildRankName, rankIndex = guildRankIndex}
end
function BohemkaDKP:GetMainCharacter(characters)
    local mainChar
    local mainCharData
    for name, data in pairs(characters) do
        if not mainCharData or data.rankIndex < mainCharData.rankIndex then
            mainCharData = data
            mainChar = name
        end
    end
    if mainCharData then
        return mainChar, mainCharData.rank, mainCharData.rankIndex
    else
        return nil, nil, nil
    end

end
function BohemkaDKP:IsPlayerAlt()
    local _, guildRankName, _  = GetGuildInfo("player")
    if guildRankName == "Alt" or not self:IsPlayerMain() then
        return true
    end
    return false
end
function BohemkaDKP:IsPlayerMain()
    return self:GetMainCharacter() == self:GetPlayerName(true)
end
function BohemkaDKP:OnCharactersInfo(characters, sender)
    characters = { strsplit(",", characters) }
    if not RosterData.characters then
        RosterData.characters = {}
    end
    RosterData.characters[sender] = characters
end
function BohemkaDKP:ShareCharactersInfo()
    local tmp = {}
    local playerName = self:GetPlayerName(true)
    local characters = self:GetCharacters()
    if not characters then
        return
    end
    for name, _ in pairs(characters) do
        if name ~= playerName then
            tmp[#tmp + 1] = name
        end
    end
    local payload = table.concat(tmp, ",")
    self:SendEvent("GUILD", self.EVENT.CHARACTERS_INFO, payload)
end
function BohemkaDKP:RequestCharactersInfo()
    self:SendEvent("GUILD", self.EVENT.CHARACTERS_INFO_REQUEST)
end

function BohemkaDKP:OnCharactersInfoRequest(sender)
    if sender == self:GetPlayerName(true) then
        return
    end
    self:ShareCharactersInfo()
end
function BohemkaDKP:GetCharacters()
    local realm = GetRealmName()
    local guildName = GetGuildInfo("player")
    return AccountData.characters[realm][guildName]
end
function BohemkaDKP:GetGuildMemberCharactersData(fullName)
    if not self.guildRoster[fullName] then
        return
    end
    local tmp = {
        [fullName] = {
            rank = self.guildRoster[fullName][2],
            rankIndex = self.guildRoster[fullName][3],
        }
    }
    if RosterData.characters[fullName] then
        for _, name in ipairs(RosterData.characters[fullName]) do
            if self.guildRoster[name] then
                tmp[name] = {
                    rank = self.guildRoster[name][2],
                    rankIndex = self.guildRoster[name][3],
                }
            end
        end
    end
    return tmp
end
function BohemkaDKP:GetGuildMemberCharactersDataTooltip(fullName)
    local tmp = {}
    if RosterData.characters[fullName] then
        for _, name in ipairs(RosterData.characters[fullName]) do
            if self.guildRoster[fullName] then
                tmp[#tmp + 1] = strsplit("-", name).." - "..self.guildRoster[name][2]
            end
        end
    end
    return table.concat(tmp, "\n")
end
function BohemkaDKP:IsMemberAlt(name)
    if self.guildRoster[name][2] == "Alt" or not self:IsPlayerMain() then
        return true
    end
    return false
end
